<template>
   <v-card>
      <v-card-title class="subheading ">
        <div>{{$i18n.t("timeline.title")}}</div>
        <v-spacer />
        
        <v-menu bottom left>
            <v-btn slot="activator" icon>
              <v-icon>sort</v-icon>
            </v-btn>
            <v-list dense>
              <v-list-tile @click="newestFirst = true" :disabled="newestFirst==true">
                <v-list-tile-title>{{$i18n.t("common.sort.newest_first")}}</v-list-tile-title>
              </v-list-tile>
              <v-list-tile @click="newestFirst = false" :disabled="newestFirst==false">
                <v-list-tile-title>{{$i18n.t("common.sort.oldest_first")}}</v-list-tile-title>
              </v-list-tile>
            </v-list>
          </v-menu>
          
      </v-card-title>
      
      <v-img
        src="/resources/img/interview.jpg"
        gradient="to top, rgba(0,127,255,.44), rgba(0,127,255,.44)" height="100px" />
        
      <v-card-text>
        <v-timeline v-if="events.length > 0" dense align-top>
            <v-timeline-item 
              v-for="(event, index) in events"
              :key="index"
              small fill-dot 
              :icon="event.icon"
              :color="event.color || secondary" >
                      <v-card  raised class="pt-0">.
                        <v-card-title class="mt-0 pt-0">
                            <v-layout row wrap>
                                <v-flex xs12><span style="font-weight: bold !important;">{{event.text}}</span></v-flex>                                                        
                                <v-flex xs12 class="caption" style="font-size: 11px !important; color: #777;">
                                    {{event.date}}
                                </v-flex>
                            </v-layout>
                        </v-card-title>
                        <v-divider/>
                        <v-card-text>
                          <div class="body-2" style="font-weight: 400" v-html="event.details"></div>
                        </v-card-text>
                      </v-card> 
            </v-timeline-item>
          </v-timeline>
            <!-- TODO TIMELINE for XS -->
      </v-card-text>
  </v-card>
</template>

<script>  
import moment from 'moment'
export default {
    name: 'HistoryCard',
    props: ['application'],
  data() {
    return {
        newestFirst: true
    }
  },
  methods: {
    capitalize(s) {
        return s.substring(0, 1).toUpperCase() + s.substring(1)
    },
    getIcon(newStatus, oldStatus) {
        if ( oldStatus == 'CLOSED' ) return 'unarchive'
        switch ( newStatus ) {
            case 'SAVED': return 'work_outline';
            case 'APPLIED': return 'check';
            case 'IN_PROGRESS': return 'cached';
            case 'CLOSED': return 'move_to_inbox';
            default: return '';
        }
    },
    getUserFriendlyStatusText(status) {
        return !status ? '-' : this.$i18n.t(`application.status.${status.toLowerCase()}`)
    },
    getFirstStatus(events, defaultStatus) {
        let firstStatus = null
        if ( events && events.length > 0 ) {
            const all = [...events].sort((a, b) => {
                return a.applicationDate - b.applicationDate
            })
            const event = all[0]
            if ( event.field == 'status' && event.field.oldValue ) {
                firstStatus = event.oldValue.status
            }
        }
        return this.getUserFriendlyStatusText(firstStatus || defaultStatus)
    }
  },
  computed: {
    datePattern() {
        return this.$i18n.t("timeline.datePattern")
    },
    events() {
        let events = this.application.events.reduce((accu, event) => { 
            const newValue = event.newValue[event.field + 'Value']
            const oldValue = event.oldValue[event.field + 'Value']
            const statusChangedText = this.$i18n.t("timeline.field.head", {field: this.capitalize(this.$i18n.t("application.fields." + event.field))})
            const archivedText = newValue == 'CLOSED' ? this.$i18n.t("timeline.application.archived") : undefined
            const unarchivedText = oldValue == 'CLOSED' ? this.$i18n.t("timeline.application.unarchived") : undefined
            const field = this.$i18n.t("application.fields." + event.field)
            const value = "<strong>" + this.getUserFriendlyStatusText(newValue) + "</strong>"
            accu.push({ 
                raw: event,
                date: moment(event.date).format(this.datePattern),
                newValue,
                oldValue,
                type: 'VALUE',
                text: archivedText || unarchivedText || statusChangedText,
                icon: event.field == 'status' ? this.getIcon(newValue, oldValue) : '',
                color: 'primary',
                details: this.$i18n.t("timeline.field.change", { field, value })
            }); 
            return accu; 
        }, []);
        
        this.application.interviews.forEach((interview) => {
            const interviewType = this.$i18n.t(`interview.type.${interview.type.toLowerCase()}`);
            events.push({
                raw: interview,
                date: moment(interview.date).format(this.datePattern),
                type: 'INTERVIEW',
                interview: interview,
                text: this.$i18n.t(interview.done ? "timeline.interview.attended" : "timeline.interview.scheduled", { interview: interviewType } ),
                color: interview.done ? 'success' : 'pink',
                icon: interview.done ? 'done_all' : 'event',
                details: (() => { 
                    let html = interview.description || ""
                    if ( interview.type == 'ON_SITE' ) {
                        const space = interview.description ? "mt-2" : ""
                        html += `<div class="${space} caption" style="white-space: pre-line;">${interview.location}</div>`
                    }
                    return html
                })()
            })
        });
        
        const firstStatus = "<strong>" + this.getFirstStatus(this.application.events, this.application.status) + "</strong>"
        events.push({
            raw: Object.assign({}, this.application, { date: this.application.applicationDate }),
            icon: 'add',
            color: 'primary',
            date: moment(this.application.applicationDate).format(this.datePattern),
            text: this.$i18n.t("timeline.application.created"),
            details: this.$i18n.t("timeline.withStatus", {value: firstStatus})
        })
        
        return events.sort((a, b) => {
            const diff = moment(b.raw.date).valueOf() - moment(a.raw.date).valueOf()
            return this.newestFirst ? diff : -diff
        })
    }
  }
}

</script>